
import java.awt.*;
import java.lang.*;
import java.io.*;
import java.util.*;

public class MyFrame extends Frame {

    static  MyFrame  myFrame; 
    private MenuBar  mbar;
//    private Panel    p; 
//    private TextArea t; 

    public MyFrame(String title) 
    {
       super(title);
       setBackground(Color.white);

       InitializeMenus();

       setResizable(true);
       setMenuBar(mbar);
       setLayout(new BorderLayout());
       resize(800,400);
 
       Dimension d = new Dimension(this.size());

       TextArea t = new TextArea("Text Area",d.height/14,d.width/8);
       t.setEditable(true);
    
       Panel p = new Panel();

       p.add("Center", t);

       add("Center", p);

       layout();
       show();

       DebugComponent(t);
       DebugComponent(p);

    }

    private void InitializeMenus() 
    {
       mbar = new MenuBar();

       Menu m = new Menu("File");
       m.add(new MenuItem("New"));
       m.add(new MenuItem("Open"));
       m.add(new MenuItem("Save"));
       m.add(new MenuItem("Save As..."));
       m.addSeparator();
       m.add(new MenuItem("Quit"));            
       mbar.add(m);

       m = new Menu("Piemontesi...");
       m.add(new MenuItem("Al picciune"));
       m.add(new MenuItem("Suo fratello"));
       mbar.add(m);

       m = new Menu("Help");
       m.add(new MenuItem("Help!!!!"));
       m.add(new MenuItem("Online documents"));
       m.addSeparator();
       m.add(new MenuItem("About..."));
       mbar.add(m);
    }

    public boolean handleEvent(Event evt) 
    {
        switch(evt.id) 
        {
            System.out.println(evt.target.toString());
            case Event.WINDOW_DESTROY: 
            {
                System.out.println("Exiting...");
                System.exit(0);
                return true;
            }
            case Event.ACTION_EVENT: 
            {
                if(evt.target instanceof MenuItem) 
                {
                    if("Quit".equals(evt.arg)) 
                    {       
                        System.exit(0);
                    }
                    if("Save".equals(evt.arg)) 
                    {       
                        DebugComponent(myFrame);
                    }
                    if("Al picciune".equals(evt.arg)) 
                    {       
                        System.out.println("Al picciune is pressed");
                    }
                    if("Suo fratello".equals(evt.arg)) 
                    {       
                        System.out.println("Suo fratello is pressed");
                    }
                    if("New".equals(evt.arg)) 
                    {
                        MyFrame mf = new MyFrame("New");
                    }
                    if("About...".equals(evt.arg)) 
                    {
                        AboutDialog ab = new AboutDialog(this);
                        ab.move(400,560);
                        ab.show();
                        DebugComponent(ab);
                    }
                }
            }
            default: return false;
        }
    }

    public void DebugComponent(Component component)
    {
       System.out.println("");
       component.list();

       System.out.print("        getParent: ");
       System.out.println(component.getParent());

       System.out.print("        location: ");
       System.out.println(component.location());

       System.out.print("        size: ");
       System.out.println(component.size());

       System.out.print("        preferredSize: ");
       System.out.println(component.preferredSize());
    }

    public static void main(String args[]) 
    {
       myFrame = new MyFrame("Frame Test Application");
       
       myFrame.move(200,200);
       myFrame.show();

    }
}

class AboutDialog extends Dialog 
{
    public AboutDialog(MyFrame parent) 
    {
       super(parent, "About... ", true);
       this.setResizable(false);
       Panel p = new Panel();
       p.add(new Button("OK"));
       add("South", p);
       resize(300,100);
    }
    public boolean handleEvent(Event evt) 
    {
       switch(evt.id) 
       {
           case Event.ACTION_EVENT:
           {
                if("OK".equals(evt.arg)) 
                {
                    hide();
                    return true;
                }
            }
            default: return false;
        }
    }
}


